(function() {
    var winnerPayout = $.getSetIniDbNumber('bingoSettings', 'bingoPayout', 100),
		lastWinner = $.getSetIniDbString('bingoSettings', 'bingoWinner', "N/A"),
		gameStarted = false,
		winningNumber = 0,
		maxNumber = 0;
    /**
     * @event command
     */
    $.bind('command', function(event) {
        var sender = event.getSender().toLowerCase(),
            command = event.getCommand(),
            args = event.getArgs(),
            action = args[0],
            actionArgs1 = args[1],
			isMod = $.isModv3(sender, event.getTags());
		
        if (command.equalsIgnoreCase('bingo')) {
			if (!action || (!isMod && isNaN(action))) {
				if(isMod && !gameStarted) {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.noargsmod'));
				} else {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.noargs', maxNumber));
				}
				return;
			}
            
			if(action.equalsIgnoreCase('set')) {
				if (!actionArgs1 || isNaN(actionArgs1)) {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.set.fail'));
					return;
				}
				winnerPayout = Number(actionArgs1);
				$.setIniDbString('bingoSettings', 'bingoPayout', winnerPayout);
				$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.set.success',  $.getPointsString(winnerPayout)));
				return;
			} else if (action.equalsIgnoreCase('stop')) {
				if(!gameStarted) {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.stop.fail'));
					return;
				}
				gameStarted = false;
				$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.stop.success', winningNumber));
				winningNumber = 0;
				maxNumber = 0;
			} else if (action.equalsIgnoreCase('last')) {
				$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.lastwinner', lastWinner));
			} else {
				if(!isMod && !gameStarted) {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.nogame'));
					return;
				}
				if(isMod && !gameStarted) {
					maxNumber = parseInt(action);
					winningNumber = $.randRange(1, maxNumber);
					gameStarted = true;
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.start', maxNumber));
					return;
				}
				if(parseInt(action) == winningNumber) {
					lastWinner = sender;
					gameStarted = false;
					$.setIniDbString('bingoSettings', 'bingoWinner', lastWinner);
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.guess.winner', $.getPointsString(winnerPayout)));
				} else {
					$.say($.whisperPrefix(sender) + $.lang.get('bingo.game.guess.loser'));
				}
			}
		}
    });
    
    /**
     * @event initReady
     */
    $.bind('initReady', function() {
		$.registerChatCommand('./custom/games/bingoGame.js', 'bingo', 7);
        $.registerChatSubcommand('bingo', 'stop', 2);
        $.registerChatSubcommand('bingo', 'last', 2);
        $.registerChatSubcommand('bingo', 'set', 1);
    });
})();
